/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/
#ifndef SASCRDEFSH_
#define SASCRDEFSH_

// turn off debugging info
#define SASCR_SILENT

/////////////////////////////////////////////////////////////
// macro to determine # of args in an array
#define ARRAYSIZE(a)    (sizeof(a)/sizeof(a[0]))

////////////////////////////////////////////////////////////////

#define CTX(x) ((unsigned long)(1 << ((unsigned long)x)))
#define IsCTX(__evalCtx, __varCtx) (((__evalCtx & __varCtx) == __varCtx) ? true : false)
#define CTXALL ((unsigned long)(-1))

////////////////////////////////////////////////////////////////

#define SA_VAR_TRUE     _T( "1" )
#define SA_VAR_FALSE    _T( "0" )
#define SA_VAR_ERROR    _T( "???" )

////////////////////////////////////////////////////////////////

extern const TCHAR g_operSeparatorStart;
extern const TCHAR g_operSeparatorStop;
extern const TCHAR g_operParamSeparator;
extern const TCHAR g_variablePrefix;

////////////////////////////////////////////////////////////////

#endif
