// TestPropertyPage.cpp : fichier d'implmentation
//

#include "stdafx.h"
#include "TestPropertyPage.h"


// Bote de dialogue CTestPropertyPage
LRESULT CALLBACK NewWindowProc(HWND hwnd, UINT message, LPARAM lParam);

IMPLEMENT_DYNAMIC(CTestPropertyPage, CPropertyPage)
CTestPropertyPage::CTestPropertyPage(prefsDlgRec *ini, UINT nIDTemplate) : CPropertyPage(nIDTemplate) {
    NameBackup = new TCHAR[_tcslen(ini->name) + 1];
    _tcscpy(NameBackup, ini->name);
    PageDataBackup = new prefsDlgRec;
    memcpy(PageDataBackup, ini, sizeof(prefsDlgRec));
    PageDataBackup->name = NameBackup;
}

CTestPropertyPage::~CTestPropertyPage() {
    m_psp.pfnDlgProc = sauvegarde;
    delete NameBackup;
    delete PageDataBackup;
    if(this->m_hWnd != NULL)
		this->DestroyWindow();
}

void CTestPropertyPage::DoDataExchange(CDataExchange *pDX) {
    CPropertyPage::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(CTestPropertyPage, CPropertyPage)
END_MESSAGE_MAP()

LRESULT CALLBACK NewPageCallbackProc(HWND hwnd, UINT uMsg, LPPROPSHEETPAGE ppsp) {
    //    TRACE(_T("uMsg %d %s\n"), uMsg, ppsp->pszTitle);
    switch(uMsg) {
        case PSPCB_CREATE:
            // The page is being created.  Return nonzero to let it be created,
            return 1;
            break;

        case PSPCB_RELEASE:
            // The page is being destroyed.  Put any cleanup code (eg, free up
            // memory or resources) here.  The return value is ignored.
            return 0;
            break;
    }

    return 0;
}

void CTestPropertyPage::InstallHook() {
    memset(&m_psp, 0, sizeof(PROPSHEETPAGE));
    m_psp.dwSize = sizeof(PROPSHEETPAGE);
    m_psp.dwFlags = PSP_USECALLBACK;
    sauvegarde = m_psp.pfnDlgProc;
    m_psp.pfnDlgProc = (DLGPROC) (PageDataBackup->proc);
    m_psp.hInstance = PageDataBackup->hInst;
    m_psp.pszTemplate = MAKEINTRESOURCE(PageDataBackup->dlgID);
    m_psp.pfnCallback = (LPFNPSPCALLBACK) NewPageCallbackProc;
    m_psp.lParam = (LPARAM) PageDataBackup;
}

LRESULT CALLBACK NewWindowProc(HWND hwnd, UINT message, LPARAM lParam) {
    BOOL bRet = FALSE;
    TRACE(_T("message %d %d \n"), message, lParam);
    //  bRet = ((PFNPROPSHEETCALLBACK)gen)(hwnd, message, lParam);
    return bRet;
}

// Gestionnaires de messages CTestPropertyPage
