#include "../stdafx.h"
#include "FrameManager.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

FrameManager::FrameManager(int size) {
    taille = 0;
    maxSize = size;
    Frames = (Frame * *) calloc(size, sizeof(Frame *));
    for(int i = 0; i < maxSize; i++) {
        Frame *tmp = new Frame();
        *(Frames + i) = tmp;
    }
}

FrameManager::~FrameManager() {
    for(int i = 0; i < maxSize; i++) {
        Frame *tmp = *(Frames + i);
        delete tmp;
    }
    delete Frames;
}

void FrameManager::Add(Frame frame, int index) {
    if(index == -1)
        (**(Frames + taille++)).copy(frame);
    else {
        if(index < taille)
            (**(Frames + index)).copy(frame);
        else {
            (**(Frames + taille)).copy(frame);
            taille++;
        }
    }
}

Frame FrameManager::Get(int index) {
    return *(*(Frames + index));
}

int FrameManager::GetSize() {
    return taille;
}

void FrameManager::RemoveAll() {
    taille = 0;
}

void FrameManager::RemoveAt(int index) {
    for(int i = index; i < taille - 1; i++)
        (*(Frames + i))->copy(*(*(Frames + i + 1)));
}
