/*********************************************************************

   Copyright (C) 2002 Smaller Animals Software, Inc.

   This software is provided 'as-is', without any express or implied
   warranty.  In no event will the authors be held liable for any damages
   arising from the use of this software.

   Permission is granted to anyone to use this software for any purpose,
   including commercial applications, and to alter it and redistribute it
   freely, subject to the following restrictions:

   1. The origin of this software must not be misrepresented; you must not
     claim that you wrote the original software. If you use this software
     in a product, an acknowledgment in the product documentation would be
     appreciated but is not required.

   2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.

   3. This notice may not be removed or altered from any source distribution.

   http://www.smalleranimals.com
   smallest@smalleranimals.com

**********************************************************************/
#ifndef SASTRINGARRAYH
#define SASTRINGARRAYH

////////////////////////////////////////////////////////////////

#pragma warning(disable:4786)

#include <vector>

using namespace std ;
using namespace std::rel_ops ;

#include "SAScrString.h"

////////////////////////////////////////////////////////////////

class CSAStringArray : public vector<CSAString>
{
public:
   int GetSize();          
   int Add(CSAString &s);
   //
   //	[JRT]	Since This Is Based On "vector", Which 
   //	Uses "unsigned int" Values For Size/Index...
   //
//   CSAString GetAt(int i);
   CSAString GetAt(DWORD dw);
   void RemoveAll();
};

#endif