#if !defined( SASCRIPT_H__8CC33764_4C6A_4551_9FCC_083599A13F09__INCLUDED_ )
#define 	SASCRIPT_H__8CC33764_4C6A_4551_9FCC_083599A13F09__INCLUDED_
/*|*\
|*|  File:      SAScript.h
|*|  
|*|  By:        James R. Twine, JRTwine Software, LLC
|*|             Copyright 2002, JRTwine Software, LLC
|*|  Date:      Friday, August 9, 2002
|*|             
|*|  Notes:     This File Provides For Automagic Linking With The
|*|             Correct Version Of The SAScriptLib Library.
|*|             
|*|             When You Are Building To Link WITH The SAScript Library,
|*|             Be Sure That The Identifier __BUILDING_SASCRIPTLIB Is
|*|				NOT Defined!
|*|             
|*|             The Convenience Of This Feature Is That It Allows
|*|				All Versions Of The SAScriptLib Library To Be
|*|             Placed In A Single Directory, And Your Application
|*|             Will Automatically Link With The Correct One.
|*|             
|*|             SAScript And All Original Related Source Code Are
|*|				Copyright (C) 2002 Smaller Animals Software, Inc.
\*|*/
#if !defined( __BUILDING_SASCRIPTLIB )						// If NOT Building The Library Proper
#if defined( _DEBUG )										// If A Debug Build
#if defined( _UNICODE )										// If A Unicode-Debug Build
#define		SASCRIPT_LIB_NAME	"SAScriptLib_ud.lib"		// Set Lib Name To "_ud" Name
#else														// If An ANSI-Debug Build
#define		SASCRIPT_LIB_NAME	"SAScriptLib_d.lib"			// Set Lib Name To "_d" Name
#endif
#else														// If Not A Debug Build (Ergo, A Release Build)
#if defined( _UNICODE )										// If A Unicode-Release Build
#define		SASCRIPT_LIB_NAME	"SAScriptLib_u.lib"			// Set Lib Name To "_u" Name
#else														// If An ANSI-Release Build
#define		SASCRIPT_LIB_NAME	"SAScriptLib.lib"			// Set Lib Name To Normal Filename
#endif
#endif
#pragma comment( lib, SASCRIPT_LIB_NAME )					// Automagically Link With The Correct Library	
#pragma message( "SAScript.h(40): Automatically Linking With: " SASCRIPT_LIB_NAME )
#endif														

#endif		// SASCRIPT_H__8CC33764_4C6A_4551_9FCC_083599A13F09__INCLUDED_
