#ifndef TAGEDITOR_H
#define TAGEDITOR_H

#include "Tools/MenuXP.h"
#include "Tools/ButtonXP.h"

/////////////////////////////////////////////////////////////////////////////
// CTagEditor dialog

class CTagEditor : public CDialog {
        // Construction
    public:
        CTagEditor(UINT id, CWnd *pParent = NULL);   // standard constructor


        // Dialog Data
        enum {
            IDD = IDD_TAGEDIT
        };

        CButtonXP m_btn_Cancel;
        CButton m_btn_Keep1;
        CButton m_btn_Keep2;
        CButton m_btn_Keep3;
        CButton m_btn_Keep4;
        CButton m_btn_Keep5;
        CButton m_btn_Keep6;
        CButtonXP m_btn_RemoveTag;
        CButtonXP m_btn_Ok;
        CComboBox m_c_genre;
        CEdit m_c_title;
        CEdit m_c_comment;
        CEdit m_c_artist;
        CEdit m_c_album;
        CEdit m_c_year;
        int m_genre;
        CString m_album;
        CString m_artist;
        CString m_comment;
        CString m_filename;
        CString m_title;
        CString m_year;
        BOOL m_keep1;
        BOOL m_keep2;
        BOOL m_keep3;
        BOOL m_keep4;
        BOOL m_keep5;
        BOOL m_keep6;


        // Overrides
    protected:
        virtual void DoDataExchange(CDataExchange *pDX);  // DDX/DDV support

        // Implementation
    protected:
        virtual BOOL OnInitDialog();
        virtual void OnOK();
        afx_msg void OnRemoveTag();
        DECLARE_MESSAGE_MAP()
        DECLARE_MENUXP()
};

#endif
